package org.simantics.graph.compiler;

import java.util.List;

import org.simantics.databoard.Bindings;
import org.simantics.databoard.binding.Binding;
import org.simantics.databoard.serialization.Serializer;

public class SourceInfo {
	public static final Binding BINDING = Bindings.getBindingUnchecked(SourceInfo.class);
	public static final Serializer SERIALIZER = Bindings.getSerializerUnchecked(BINDING);		
	
	public List<SourceFile> sourceFiles;
	
	public static class SourceFile {
		public String name;
		public List<Variable> variables;
		public List<DefinitionPosition> definitionPositions;
		
		public SourceFile(String name, List<Variable> variables, List<DefinitionPosition> definitionPositions) {
			this.name = name;
			this.variables = variables;
			this.definitionPositions = definitionPositions;
		}
	}
	
	public static class Variable {
		public String name;		
		public int    resource;
		
		public Variable(String name, int resource) {
			this.name = name;
			this.resource = resource;
		}
	}
	
	public static class DefinitionPosition {
		public int    resource;
		public int    line;
		public int    begin;
		public int    end;
		
		public DefinitionPosition(int resource, int line, int begin, int end) {
			this.resource = resource;
			this.line = line;
			this.begin = begin;
			this.end = end;
		}
	}
	
	public SourceInfo(List<SourceFile> sourceFiles) {
		this.sourceFiles = sourceFiles;
	}
}
